/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.codegen.testmodel;

import rx.Observable;
import rx.Single;
import io.vertx.rx.java.RxHelper;
import io.vertx.rx.java.WriteStreamSubscriber;
import io.vertx.rx.java.SingleOnSubscribeAdapter;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.codegen.testmodel.FutureTCK original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.codegen.testmodel.FutureTCK.class)
public class FutureTCK {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    FutureTCK that = (FutureTCK) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<FutureTCK> __TYPE_ARG = new TypeArg<>(    obj -> new FutureTCK((io.vertx.codegen.testmodel.FutureTCK) obj),
    FutureTCK::getDelegate
  );

  private final io.vertx.codegen.testmodel.FutureTCK delegate;
  
  public FutureTCK(io.vertx.codegen.testmodel.FutureTCK delegate) {
    this.delegate = delegate;
  }

  public FutureTCK(Object delegate) {
    this.delegate = (io.vertx.codegen.testmodel.FutureTCK)delegate;
  }

  public io.vertx.codegen.testmodel.FutureTCK getDelegate() {
    return delegate;
  }

  public void asyncMethod(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>> handler) { 
    delegate.asyncMethod(handler);
  }

  public void asyncMethod() {
    asyncMethod(ar -> { });
  }

    public rx.Single<java.lang.Void> rxAsyncMethod() { 
    return Single.create(new SingleOnSubscribeAdapter<>(fut -> {
      asyncMethod(fut);
    }));
  }

  public static FutureTCK newInstance(io.vertx.codegen.testmodel.FutureTCK arg) {
    return arg != null ? new FutureTCK(arg) : null;
  }

}
