/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.codegen.testmodel;

import rx.Observable;
import rx.Single;
import io.vertx.rx.java.RxHelper;
import io.vertx.rx.java.WriteStreamSubscriber;
import io.vertx.rx.java.SingleOnSubscribeAdapter;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.codegen.testmodel.GenericNullableRefedInterface original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.codegen.testmodel.GenericNullableRefedInterface.class)
public class GenericNullableRefedInterface<T> {

  @Override
  public String toString() {
    return delegate.toString();
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    GenericNullableRefedInterface that = (GenericNullableRefedInterface) o;
    return delegate.equals(that.delegate);
  }
  
  @Override
  public int hashCode() {
    return delegate.hashCode();
  }

  public static final TypeArg<GenericNullableRefedInterface> __TYPE_ARG = new TypeArg<>(    obj -> new GenericNullableRefedInterface((io.vertx.codegen.testmodel.GenericNullableRefedInterface) obj),
    GenericNullableRefedInterface::getDelegate
  );

  private final io.vertx.codegen.testmodel.GenericNullableRefedInterface<T> delegate;
  public final TypeArg<T> __typeArg_0;
  
  public GenericNullableRefedInterface(io.vertx.codegen.testmodel.GenericNullableRefedInterface delegate) {
    this.delegate = delegate;
    this.__typeArg_0 = TypeArg.unknown();  }

  public GenericNullableRefedInterface(Object delegate, TypeArg<T> typeArg_0) {
    this.delegate = (io.vertx.codegen.testmodel.GenericNullableRefedInterface)delegate;
    this.__typeArg_0 = typeArg_0;
  }

  public io.vertx.codegen.testmodel.GenericNullableRefedInterface getDelegate() {
    return delegate;
  }

  public T getValue() { 
    T ret = (T)__typeArg_0.wrap(delegate.getValue());
    return ret;
  }

  public static <T> GenericNullableRefedInterface<T> newInstance(io.vertx.codegen.testmodel.GenericNullableRefedInterface arg) {
    return arg != null ? new GenericNullableRefedInterface<T>(arg) : null;
  }

  public static <T> GenericNullableRefedInterface<T> newInstance(io.vertx.codegen.testmodel.GenericNullableRefedInterface arg, TypeArg<T> __typeArg_T) {
    return arg != null ? new GenericNullableRefedInterface<T>(arg, __typeArg_T) : null;
  }

}
