/*
 * Copyright 2014 Red Hat, Inc.
 *
 * Red Hat licenses this file to you under the Apache License, version 2.0
 * (the "License"); you may not use this file except in compliance with the
 * License.  You may obtain a copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package io.vertx.rxjava.codegen.testmodel;

import rx.Observable;
import rx.Single;
import io.vertx.rx.java.RxHelper;
import io.vertx.rx.java.WriteStreamSubscriber;
import io.vertx.rx.java.SingleOnSubscribeAdapter;
import java.util.Map;
import java.util.Set;
import java.util.List;
import java.util.Iterator;
import java.util.function.Function;
import java.util.stream.Collectors;
import io.vertx.core.Handler;
import io.vertx.core.AsyncResult;
import io.vertx.core.json.JsonObject;
import io.vertx.core.json.JsonArray;
import io.vertx.lang.rx.RxGen;
import io.vertx.lang.rx.TypeArg;
import io.vertx.lang.rx.MappingIterator;

/**
 *
 * <p/>
 * NOTE: This class has been automatically generated from the {@link io.vertx.codegen.testmodel.SuperInterface2 original} non RX-ified interface using Vert.x codegen.
 */

@RxGen(io.vertx.codegen.testmodel.SuperInterface2.class)
public interface SuperInterface2 {

  io.vertx.codegen.testmodel.SuperInterface2 getDelegate();

  public void otherSuperMethodWithBasicParams(byte b, short s, int i, long l, float f, double d, boolean bool, char ch, java.lang.String str);

  public static SuperInterface2 newInstance(io.vertx.codegen.testmodel.SuperInterface2 arg) {
    return arg != null ? new SuperInterface2Impl(arg) : null;
  }

}

class SuperInterface2Impl implements SuperInterface2 {
  private final io.vertx.codegen.testmodel.SuperInterface2 delegate;
  
  public SuperInterface2Impl(io.vertx.codegen.testmodel.SuperInterface2 delegate) {
    this.delegate = delegate;
  }

  public SuperInterface2Impl(Object delegate) {
    this.delegate = (io.vertx.codegen.testmodel.SuperInterface2)delegate;
  }

  public io.vertx.codegen.testmodel.SuperInterface2 getDelegate() {
    return delegate;
  }

  public void otherSuperMethodWithBasicParams(byte b, short s, int i, long l, float f, double d, boolean bool, char ch, java.lang.String str) { 
    delegate.otherSuperMethodWithBasicParams(b, s, i, l, f, d, bool, ch, str);
  }

}
